#include <iostream>
#include <queue>
#define MAX_N 2006
using namespace std;

bool table[MAX_N][MAX_N];
int n, m;
bool used[MAX_N];

bool bfs(int start, int f)
{
    fill_n(used, n+3, false);
    queue<int> opashka;
    int k;
    opashka.push(start);

    while(!opashka.empty())
    {
        k=opashka.front();
        opashka.pop();

        for(int i=0; i<MAX_N; i++)
        {
            if(table[k][i] && !used[i])
            {
                opashka.push(i);
                used[i]=true;
                if(i==f)
                {
                    return true;
                }
            }
        }
    }
    return false;
}

int main()
{
    cin >> n >> m;

    for(int i=1; i<n; i++)
    {
        table[i][i+1]=true;
    }

    for(int i=2*n; i>=n+2; i)
    {
        table[i][i-1]=true;
    }

    char z;
    int v1, v2;

    for(int i=0; i<m; i++)
    {
        cin >> z >> v1 >> v2;

        if(z=='A')
        {
            table[v1][v2]=true;
            table[v2][v1]=true;
        }
        else if(z=='B')
        {
            table[v1][v2]=false;
            table[v2][v1]=false;
        }
        else if(z=='Q')
        {
            if(bfs(v1, v2))
            {
                cout << "YES";
            }
            else
            {
                cout << "NO";
            }
        }
    }




    return 0;
}
