#include <bits/stdc++.h>
#define endl '\n'
using namespace std;
void FastIO()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}
int n, q;
const int MAXN = 100555;
const int MAXM = 20555;
vector < int > G[MAXN];
int used[MAXM][MAXM];
bool mem[MAXM];
/*
5 6
A 4 9
Q 1 7
B 3 2
Q 1 7
A 1 8
Q 1 7

yes
no
yes
*/
void dfs(int node, int v, bool &tf)
{
    if(!G[node].size() || mem[node] == 1) return;
    for(int p = 0; p < G[node].size(); p ++)
    {
        if(mem[node]) continue;
        mem[node] = 1;
        if(G[node][p] == v)
        {
            tf = 1;
            //cout << "YES" << endl;
            return;
        }
        dfs(G[node][p], v, tf);
        mem[node] = 0;
    }
}
int main ()
{
    FastIO();
    cin >> n >> q;
    for(int i = 1; i < n; i ++)
    {
        G[i].push_back(i+1);
        used[i][i+1] = 1;
    }
    for(int i = 1; i < n; i ++)
    {
        G[i+n+1].push_back(i+n);
        used[i+n+1][i+n] = 1;
    }
    for(int i = 0; i < q; i ++)
    {
        char ch;
        int b, e;
        cin >> ch >> b >> e;
        if(ch == 'A')
        {
            G[b].push_back(e);
            G[e].push_back(b);
            used[b][e] ++;
            used[e][b] ++;
        }
        else if(ch == 'B')
        {
            if(used[b][e]) used[b][e] --;
            if(used[b][e]) used[e][b] --;
            for(int j = 0; j < G[b].size(); j ++)
            {
                if(G[b][j] == e) G[b][j] = -100;
            }
            for(int j = 0; j < G[e].size(); j ++)
            {
                if(G[e][j] == b) G[e][j] = -100;
            }
        }
        else if(ch == 'Q')
        {
            bool tf = 0;
            memset(mem, 0, sizeof(mem));
            dfs(b, e, tf);
            if(tf == 0) cout << "NO" << endl;
            else cout << "YES" << endl;
        }
    }
    return 0;
}
/*
5 6
A 4 9
Q 1 7
B 3 2
Q 1 7
A 1 8
Q 1 7

*/
