#include<bits/stdc++.h>
#define lli long long
#define endl "\n"
using namespace std;
const lli MAXM=200005, INF=9999999999, MAXN=1000000000;
struct node{
    lli x, l, r;
};
node tree1[4*MAXM], tree2[4*MAXM];
lli N, M, p1, p2, tt, up, down;
char type;
set<lli> broken[2][2];
void update1(lli ind, lli l, lli r, lli q, lli d){
    if(l>q or r<q)return;
    if(l==r){
        //cout<<"a"<<ind<<" "<<l<<" "<<r<<" "<<d<<endl;
        tree1[ind].x=d;
        return;
    }
    lli mid=(l+r)/2;
    if(tree1[ind].l==0 and q<=mid){
        tree1[ind].l=tt;
        tt++;
    }else if(tree1[ind].r==0 and q>mid){
        tree1[ind].r=tt;
        tt++;
    }
    if(q<=mid)update1(tree1[ind].l, l, mid, q, d);
    if(q>mid)update1(tree1[ind].r, mid+1, r, q, d);
    tree1[ind].x=min(tree1[tree1[ind].l].x, tree1[tree1[ind].r].x);
    return;
}
lli query1(lli ind, lli l, lli r, lli ql, lli qr, lli d){
    if(l>qr or r<ql)return 0;
    if(l==r){
        //cout<<ind<<" "<<l<<" "<<tree1[ind].x<<endl;
        return tree1[ind].x;
    }
    if(ql<=l and r<=qr){
        lli mid=(l+r)/2;
        if(tree1[ind].r!=0 and tree1[tree1[ind].r].x<=d)return query1(tree1[ind].r, mid+1, r, ql, qr, d);
        if(tree1[ind].l!=0)return query1(tree1[ind].l, l, mid, ql, qr, d);
        return 0;
    }
    lli mid=(l+r)/2;
    if(tree1[ind].l==0 and tree1[ind].r==0)return 0;
    if(tree1[ind].r==0)return query1(tree1[ind].l, l, mid, ql, qr, d);
    if(tree1[ind].l==0)return query1(tree1[ind].r, mid+1, r, ql, qr, d);
    return max(query1(tree1[ind].l, l, mid, ql, qr, d), query1(tree1[ind].r, mid+1, r, ql, qr, d));
}
void update2(lli ind, lli l, lli r, lli q, lli d){
    if(l>q or r<q)return;
    if(l==r){
        //cout<<"a"<<ind<<" "<<l<<" "<<r<<" "<<d<<endl;
        tree2[ind].x=d;
        return;
    }
    lli mid=(l+r)/2;
    if(tree2[ind].l==0 and q<=mid){
        tree2[ind].l=tt;
        tt++;
    }else if(tree2[ind].r==0 and q>mid){
        tree2[ind].r=tt;
        tt++;
    }
    if(q<=mid)update2(tree2[ind].l, l, mid, q, d);
    if(q>mid)update2(tree2[ind].r, mid+1, r, q, d);
    tree2[ind].x=max(tree2[tree2[ind].l].x, tree2[tree2[ind].r].x);
    return;
}
lli query2(lli ind, lli l, lli r, lli ql, lli qr, lli d){
    //cout<<ind<<" "<<l<<" "<<r<<" "<<d<<endl;
    if(l>qr or r<ql)return INF;
    if(l==r){
        //cout<<ind<<" "<<l<<" "<<tree2[ind].x<<endl;
        return tree2[ind].x;
    }
    if(ql<=l and r<=qr){
        lli mid=(l+r)/2;
        if(tree2[ind].l!=0 and tree2[tree2[ind].l].x>=d)return query2(tree2[ind].l, l, mid, ql, qr, d);
        if(tree2[ind].r!=0)return query2(tree2[ind].r, mid+1, r, ql, qr, d);
        return INF;
    }
    lli mid=(l+r)/2;
    if(tree2[ind].l==0 and tree2[ind].r==0)return INF;
    if(tree2[ind].r==0)return query2(tree2[ind].l, l, mid, ql, qr, d);
    if(tree2[ind].l==0)return query2(tree2[ind].r, mid+1, r, ql, qr, d);
    return min(query2(tree2[ind].l, l, mid, ql, qr, d), query2(tree2[ind].r, mid+1, r, ql, qr, d));
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin>>N>>M;
    tt=2;
    for(lli i=0; i<=4*M; i++)tree1[i].x=INF;
    broken[0][0].insert(N);
    broken[0][1].insert(2*N);
    broken[1][0].insert(1);
    broken[1][1].insert(N+1);
    for(lli i=0; i<M; i++){
        cin>>type;
        if(type=='B'){
            cin>>p1>>p2;
            if(p1>p2)swap(p1, p2);
            if(p1<N)broken[0][0].insert(p1);
            else broken[0][1].insert(p1);
            if(p2<N)broken[1][0].insert(p2);
            else broken[1][1].insert(p2);
        }else if(type=='A'){
            cin>>p1>>p2;
            if(p1>p2)swap(p1, p2);
            update1(1, 1, 2*N+1, p1, p2);
            update2(1, 1, 2*N+1, p1, p2);
        }else{
            cin>>p1>>p2;
            if(p1<p2){
                auto it1=broken[0][0].lower_bound(p1), it2=broken[0][1].lower_bound(p2);
                lli end1=(*it1), end2=(*it2), ans=query1(1, 1, 2*N+1, p1, end1, end2);
                if(ans<p2)cout<<"NO"<<endl;
                else cout<<"YES"<<endl;
            }else{
                swap(p1, p2);
                auto it1=broken[1][0].upper_bound(p1), it2=broken[1][1].upper_bound(p2);
                it1--;
                it2--;
                lli beg1=(*it1), beg2=(*it2), ans=query2(1, 1, 2*N+1, beg1, p1, beg2);
                //cout<<ans<<" "<<p1<<" "<<beg1<<" "<<p2<<" "<<beg2<<endl;
                if(ans>p2)cout<<"NO"<<endl;
                else cout<<"YES"<<endl;
            }
        }
    }
    return 0;
}
/*
6 6
A 1 10
Q 12 6
B 10 11
A 12 6
Q 11 6
Q 6 11
*/
